/**
 ** MPC_plannerCntrlTaskCodels.cc
 **
 ** Codels used by the control task MPC_plannerCntrlTask
 **
 ** Author: Vivien Delsart
 ** Date: Wed Feb 23 14:12:45 CET 2011
 **
 **/

#include <portLib.h>

#include "server/MPC_plannerHeader.h"

#include <cstring>
#include <iostream>
using namespace std;

#define DEBUG 1

/*------------------------------------------------------------------------
 * SetModeCntrl  -  control codel of CONTROL request SetMode
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
SetModeCntrl(PL_SETMODE_I *SetMode_I, int *report)
{
  if(strcmp(SetMode_I->mode, "simple_planning") == 0)
    {
      SDI_F->pl_mode = SIMPLE_PL_MODE;
#if DEBUG
      cout << "Planning mode: Simple planning" << endl;
#endif
    }
  else 
    {
      SDI_F->pl_mode = UNDEFINED_PL_MODE;      
#if DEBUG
      cout << "Planning mode: Undefined planning mode" << endl;
#endif
    }

  if(strcmp(SetMode_I->output, "path") == 0)
    {
      SDI_F->pl_output = PATH_PL_OUTPUT;
#if DEBUG
      cout << "Planning output: Path" << endl;
#endif
    }
  else if(strcmp(SetMode_I->output, "straj") == 0)
    {
      SDI_F->pl_output = STRAJ_PL_OUTPUT;
#if DEBUG
      cout << "Planning output: State trajectory" << endl;
#endif
    }
  else 
    {
      SDI_F->pl_output = UNDEFINED_PL_OUTPUT;
#if DEBUG
      cout << "Planning output: Undefined planning output" << endl;
#endif
    }

  return OK;
}


/*------------------------------------------------------------------------
 * ReinitPathCntrl  -  control codel of CONTROL request ReinitPath
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
ReinitPathCntrl(int *report)
{
  SDI_F->pathRec.nbPos = 0;

  return OK;
}


// /*------------------------------------------------------------------------
//  * SetRefCorridorWidth  -  control codel of CONTROL request SetRefCorridorWidth
//  *
//  * Description:    
//  * Report: OK
//  *
//  * Returns:    OK or ERROR
//  */

// STATUS
// SetRefCorridorWidth(float *Cor_Width_I, int *report)
// {
//   SDI_F->pathRef.corridorWidth = *Cor_Width_I;

//   return OK;
// }
